package mergesort;

import java.io.File;
import java.util.Arrays;
import java.util.Scanner;

public class ComputeIntersection {

    public static int[] readNumbers(String fileName) {
        Scanner input = null;
        try {
            input = new Scanner(new File(fileName));
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        // We need to count the number of numbers first. We will read
        // through the file once simply to count how many numbers are
        // there...
        int N = 0;
        while (input.hasNextInt()) {
            int unused = input.nextInt();
            N++;
        }
        input.close();

        // Once we know how many numbers are in the file we can create an
        // array to hold them.
        int[] A = new int[N];

        // Now we have to read through the file again to put the numbers
        // into the array.
        try {
            input = new Scanner(new File(fileName));
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        int n = 0; // Where the next number will go.
        while (input.hasNextInt()) {
            A[n] = input.nextInt();
            n++;
        }
        input.close();

        return A;
    }

    public static int[] computeIntersectionByMerging(int[] one, int[] two) {
        int[] temp = new int[one.length]; // The intersection will be no bigger than this
        int n = 0; // Where the next number in temp goes

        int i = 0, j = 0; // Indices that walk across one and two
        while (i < one.length && j < two.length) {
            if (one[i] == two[j]) {
                temp[n] = one[i];
                n++;
                i++;
                j++;
            } else if (one[i] < two[j]) {
                i++;
            } else {
                j++;
            }
        }

        // Make a new array with the right size...
        int result[] = new int[n];
        // ...and copy the numbers over to it.
        for (i = 0; i < n; i++) {
            result[i] = temp[i];
        }
        return result;
    }

    public static void main(String[] args) {
        int[] A = readNumbers("one.txt");
        int[] B = readNumbers("two.txt");
        Arrays.sort(A);
        Arrays.sort(B);
        int[] C = computeIntersectionByMerging(A, B);
        for (int n = 0; n < C.length; n++) {
            System.out.println(C[n]);
        }
    }

}
