package mergesort;

import java.io.File;
import java.util.Scanner;

public class MostCommon {

    public static int[] readNumbers(String fileName) {
        Scanner input = null;
        try {
            input = new Scanner(new File(fileName));
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        // We need to count the number of numbers first. We will read
        // through the file once simply to count how many numbers are
        // there...
        int N = 0;
        while (input.hasNextInt()) {
            int unused = input.nextInt();
            N++;
        }
        input.close();

        // Once we know how many numbers are in the file we can create an
        // array to hold them.
        int[] A = new int[N];

        // Now we have to read through the file again to put the numbers
        // into the array.
        try {
            input = new Scanner(new File(fileName));
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        int n = 0; // Where the next number will go.
        while (input.hasNextInt()) {
            A[n] = input.nextInt();
            n++;
        }
        input.close();

        return A;
    }

    public static void selectionSort(int[] list) {
        for (int i = 0; i < list.length - 1; i++) {
            // Find the minimum in the list[i..list.length-1]
            int currentMin = list[i];
            int currentMinIndex = i;

            for (int j = i + 1; j < list.length; j++) {
                if (currentMin > list[j]) {
                    currentMin = list[j];
                    currentMinIndex = j;
                }
            }

            // Swap list[i] with list[currentMinIndex] if necessary;
            if (currentMinIndex != i) {
                list[currentMinIndex] = list[i];
                list[i] = currentMin;
            }
        }
    }

    public static void main(String[] args) {
        int numbers[] = readNumbers("numbers.txt");

        // Sort the list
        selectionSort(numbers);

        // Find the most common number
        int greatestCount = 1;
        int mostCommonNumber = numbers[0];

        for (int n = 1; n < numbers.length; n++) {
            if (numbers[n] == numbers[n - greatestCount]) {
                greatestCount++;
                mostCommonNumber = numbers[n];
            }
        }

        // Print the results
        System.out.println("The number " + mostCommonNumber + " appears most often.");
        System.out.println("It appears " + greatestCount + " times in the file.");
    }
}
